use comm::Channel;
use config::Config;
use rustc_serialize::json;
use std::io;
use std::process::Command;

#[allow(dead_code)]
#[derive(RustcDecodable)]
struct I3Event {
    name: Option<String>,
    instance: Option<String>,
    button: u32,
    x: u32,
    y: u32
}

pub fn handle(_tx: &Channel, _cfg: &Config) {
    let mut line = String::new();

    // read opening [
    io::stdin().read_line(&mut line).ok().expect("Failed to read line");
    loop {
        line.clear();
        io::stdin().read_line(&mut line).ok().expect("Failed to read line");

        // the input has commas because it's supposed to be an endless array
        // of click events but we don't really care about it
        let event: I3Event = json::decode(line.trim_matches(',')).unwrap();

        match event.name.as_ref().map(String::as_ref) {
            Some("mpd") => Command::new("mpc")
                .arg("toggle")
                .output()
                .ok(),
            _ => None
        };
    }
}
